//---------------------------------------------------------------------------
//
// Name:        mfr_serial_sampleDlg.cpp
// Author:      Peter Zimmermann
// Created:     08.01.2008 02:25:32
// Description: mfr_serial_sampleDlg class implementation
//
//---------------------------------------------------------------------------

#include "mfr_serial_sampleDlg.h"

//Do not add custom headers
//wxDev-C++ designer will remove them
////Header Include Start
////Header Include End

#include "ComTools.h"

//----------------------------------------------------------------------------
// mfr_serial_sampleDlg
//----------------------------------------------------------------------------
//Add Custom Events only in the appropriate block.
//Code added in other places will be removed by wxDev-C++
////Event Table Start
BEGIN_EVENT_TABLE(mfr_serial_sampleDlg,wxDialog)
	////Manual Code Start
	////Manual Code End
	
	EVT_CLOSE(mfr_serial_sampleDlg::OnClose)
	EVT_BUTTON(ID_BTNINBYTE,mfr_serial_sampleDlg::btnInByteClick)
	EVT_BUTTON(ID_BTNOUTBYTE,mfr_serial_sampleDlg::btnOutByteClick)
	EVT_BUTTON(ID_BTNCONN,mfr_serial_sampleDlg::btnConnClick)
	EVT_BUTTON(ID_BTNOUTBIT,mfr_serial_sampleDlg::btnOutbitClick1)
END_EVENT_TABLE()
////Event Table End

mfr_serial_sampleDlg::mfr_serial_sampleDlg(wxWindow *parent, wxWindowID id, const wxString &title, const wxPoint &position, const wxSize& size, long style)
: wxDialog(parent, id, title, position, size, style)
{
	CreateGUIControls();
}

mfr_serial_sampleDlg::~mfr_serial_sampleDlg()
{
} 

void mfr_serial_sampleDlg::CreateGUIControls()
{
	//Do not add custom code here
	//wxDev-C++ designer will remove them.
	//Add the custom code before or after the blocks
	////GUI Items Creation Start

	SetTitle(wxT("mfr_serial_sample"));
	SetIcon(wxNullIcon);
	SetSize(8,8,320,334);
	Center();
	

	cbI = new wxCheckBox(this, ID_CBI, wxT("Eingang"), wxPoint(116,193), wxSize(64,17), 0, wxDefaultValidator, wxT("cbI"));

	edRead = new wxTextCtrl(this, ID_EDREAD, wxT(""), wxPoint(17,262), wxSize(171,21), wxHSCROLL, wxDefaultValidator, wxT("edRead"));

	btnInByte = new wxButton(this, ID_BTNINBYTE, wxT("Lesen"), wxPoint(193,261), wxSize(75,25), 0, wxDefaultValidator, wxT("btnInByte"));

	WxStaticLine2 = new wxStaticLine(this, ID_WXSTATICLINE2, wxPoint(17,242), wxSize(276,-1), wxLI_HORIZONTAL);

	btnOutByte = new wxButton(this, ID_BTNOUTBYTE, wxT("Senden"), wxPoint(192,189), wxSize(75,25), 0, wxDefaultValidator, wxT("btnOutByte"));

	cbB0 = new wxCheckBox(this, ID_CBB0, wxT("0"), wxPoint(72,217), wxSize(33,17), 0, wxDefaultValidator, wxT("cbB0"));

	cbB1 = new wxCheckBox(this, ID_CBB1, wxT("1"), wxPoint(72,200), wxSize(37,17), 0, wxDefaultValidator, wxT("cbB1"));

	cbB2 = new wxCheckBox(this, ID_CBB2, wxT("2"), wxPoint(72,184), wxSize(39,17), 0, wxDefaultValidator, wxT("cbB2"));

	WxStaticLine1 = new wxStaticLine(this, ID_WXSTATICLINE1, wxPoint(22,151), wxSize(269,-1), wxLI_HORIZONTAL);

	WxStaticText1 = new wxStaticText(this, ID_WXSTATICTEXT1, wxT("Ausgangs-Bit"), wxPoint(30,123), wxDefaultSize, 0, wxT("WxStaticText1"));

	cbB3 = new wxCheckBox(this, ID_CBB3, wxT("3"), wxPoint(72,168), wxSize(39,17), 0, wxDefaultValidator, wxT("cbB3"));

	cbB4 = new wxCheckBox(this, ID_CBB4, wxT("4"), wxPoint(24,217), wxSize(30,17), 0, wxDefaultValidator, wxT("cbB4"));

	cbB5 = new wxCheckBox(this, ID_CBB5, wxT("5"), wxPoint(24,200), wxSize(30,17), 0, wxDefaultValidator, wxT("cbB5"));

	cbB6 = new wxCheckBox(this, ID_CBB6, wxT("6"), wxPoint(24,184), wxSize(30,17), 0, wxDefaultValidator, wxT("cbB6"));

	cbB7 = new wxCheckBox(this, ID_CBB7, wxT("7"), wxPoint(24,168), wxSize(30,17), 0, wxDefaultValidator, wxT("cbB7"));

	lblComStat = new wxStaticText(this, ID_LBLCOMSTAT, wxT("_"), wxPoint(9,74), wxSize(291, 17), wxALIGN_CENTRE | wxST_NO_AUTORESIZE, wxT("lblComStat"));
	lblComStat->SetBackgroundColour(wxSystemSettings::GetColour(wxSYS_COLOUR_INFOBK));

	btnConn = new wxButton(this, ID_BTNCONN, wxT("Verbinden"), wxPoint(184,33), wxSize(75,25), 0, wxDefaultValidator, wxT("btnConn"));

	WxStaticText2 = new wxStaticText(this, ID_WXSTATICTEXT2, wxT("COM"), wxPoint(55,35), wxDefaultSize, wxALIGN_RIGHT, wxT("WxStaticText2"));

	sePort = new wxSpinCtrl(this, ID_SEPORT, wxT("1"), wxPoint(103,32), wxSize(64,22), wxSP_ARROW_KEYS, 1, 128, 1);

	se = new wxSpinCtrl(this, ID_SE, wxT("0"), wxPoint(112,121), wxSize(47,22),wxSP_ARROW_KEYS, 0, 7, 0);

	btnOutbit = new wxButton(this, ID_BTNOUTBIT, wxT("Senden"), wxPoint(195,119), wxSize(74,25), 0, wxDefaultValidator, wxT("btnOutbit"));
	////GUI Items Creation End
}

void mfr_serial_sampleDlg::OnClose(wxCloseEvent& /*event*/)
{
	extern int PortNum;

	if (PortNum != -1)
      {
      ComClose(PortNum);
      ComExit();
      }
	Destroy();
}


/*
 * btnOutbitClick1
 */
void mfr_serial_sampleDlg::btnOutbitClick1(wxCommandEvent& event)
{
	// insert your code here
	extern int PortNum;
	wxChar s[8];
	if (PortNum != -1)
      {
      sprintf(s,"I@@\r");
      switch (se->GetValue())
         {
         case 1:  s[2] += 2; break;
         case 2:  s[2] += 4; break;
         case 3:  s[2] += 8; break;
         case 4:  s[1] += 1; break;
         case 5:  s[1] += 2; break;
         case 6:  s[1] += 4; break;
         case 7:  s[1] += 8; break;
         default: s[2] += 1; break; 
         }
      ComWrite(PortNum,s,4);
      }
}

/*
 * btnConnClick
 */
void mfr_serial_sampleDlg::btnConnClick(wxCommandEvent& event)
{
	// insert your code here
	extern int PortNum;
	
	if (PortNum != -1) 
      {
      ComClose(PortNum);
      ComExit();
      }
	
   ComInit();
	PortNum = sePort->GetValue() - 1;
	if (!ComOpen(PortNum,9600,P_NONE,S_1BIT,D_8BIT))
      {
      lblComStat->SetLabel(wxT("Kann Port nicht ffnen"));
      PortNum = -1;
      return;
      }
   else lblComStat->SetLabel(wxT("*** ok ***"));
   
   
}

/*
 * btnOutByteClick
 */
void mfr_serial_sampleDlg::btnOutByteClick(wxCommandEvent& event)
{
	// insert your code here
	extern int PortNum;
	wxChar s[8];
	
	if (PortNum != -1)
      {
      if (cbI->GetValue()) 
         strcpy(s,"I@@\r");
      else
         strcpy(s,"O@@\r");
      if (cbB7->GetValue()) s[1] |= 0x08;
      if (cbB6->GetValue()) s[1] |= 0x04;
      if (cbB5->GetValue()) s[1] |= 0x02;
      if (cbB4->GetValue()) s[1] |= 0x01;
      if (cbB3->GetValue()) s[2] |= 0x08;
      if (cbB2->GetValue()) s[2] |= 0x04;
      if (cbB1->GetValue()) s[2] |= 0x02;
      if (cbB0->GetValue()) s[2] |= 0x01;
      ComWrite(PortNum,s,4);
      }
}

/*
 * btnInByteClick
 */
void mfr_serial_sampleDlg::btnInByteClick(wxCommandEvent& event)
{
	// insert your code here
	extern int PortNum;
	wxChar cmd[] = {'I','\r'};
	wxChar buf[1024];
	int i;
	
	if (PortNum != -1)
      {
      i = ComGetReadCount(PortNum);
      if (i > 0) ComRead(PortNum,buf,i);
      edRead->Clear();
      edRead->SetValue("");
      ComWrite(PortNum,cmd,2);
      Sleep(100);
      i = ComGetReadCount(PortNum);
      if (i > 0)
         {
         ComRead(PortNum,buf,i);
         buf[i] = 0;
         }
      else
         strcpy(buf,wxT("Keine Daten!")); 
      edRead->SetValue(buf);
      }
}
